/***************************************************************************
                          parameter.h  -  description
                             -------------------
    begin                : Sat Apr 1 2000
    copyright            : (C) 2000 by Volker Schroer
    email                : DL1KSV@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef PARAMETER_H
#define PARAMETER_H

#include <qapplication.h>
#include <qfont.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/ioctl.h>

#ifndef LINPSK_FOR_MAC
#include <sys/soundcard.h>
#endif


#include <cledbutton.h>
class CRxChannel;
class QsoInfo;
class QString;
/**Contains parameters for transmitting and receiving

some of them are set by settup
  *@author Volker Schroer
  */

class Parameter
{

public: 
	Parameter();
	~Parameter();
//bool read_config();


// Variables

/** MinimumWindowWidth */
int MinimumWindowWidth;
/** MinimumWindowHeight */
int MinimumWindowHeight;
/** Height of Statusbar */
int StatusBarHeight;


QString callsign;				// Callsign

QString inputFilename;	//Name of Demofile
QString DemoModeFileType[2]; // File Type of DemoFile
int DemoTypeNumber;				// Index of selected FileType
int serial; 						// Filedescriptor for serial Device for PTT
QString SerialDevice;
QString SoundDevice;
bool DemoMode;					// DemoMode ?

int ptt;								// Number of ComPort for PTT 0=none 1-4 Number of ComPort
int timeoffset;					// offset to UTC
int clockerror;



/** Number of Input Device
		1 = Mic
		2 = Line
		*/
int InputSource; 				
int InputVolume;				//Input Volume off Mic
int OutputVolume;				//OutputVolume (line)

bool slashed0; 				// True if to print 0 slashed

int  RxChannels;
CRxChannel * ChannelChain;
CRxChannel * ActChannel;
QsoInfo * QsoData;
BUTTONSTATUS Status;

};

#endif
